## cctbx 2025.2+ds2+~3.23.0+ds1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20...3.30 FATAL_ERROR)

project(dxtbx LANGUAGES C CXX)

# Add the included modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")

# General cmake environment configuration
include(SetDefaultBuildRelWithDebInfo) # Default builds to release with debug info
include(AlwaysColourCompilation) # Always show coloured compiler output
set(CMAKE_EXPORT_COMPILE_COMMANDS ON) # Generate compile_commands.json
set(CMAKE_CXX_STANDARD 14)

find_package(Python REQUIRED COMPONENTS Interpreter Development)
find_package(CCTBX COMPONENTS scitbx cctbx REQUIRED)
find_package(pybind11 REQUIRED)
find_package(CBFlib)

set(HDF5_USE_STATIC_LIBRARIES OFF)
find_package(HDF5 REQUIRED)
if(WIN32)
    # This is required on windows to declare symbols as external
    target_compile_definitions(hdf5::hdf5 INTERFACE H5_BUILT_AS_DYNAMIC_LIB)
endif()

# Find the boost::python library for this version of python
set(Boost_USE_STATIC_LIBS OFF) # This is the default everywhere except Windows
find_package(Boost COMPONENTS "python${Python_VERSION_MAJOR}${Python_VERSION_MINOR}" REQUIRED)


# Create Boost::python alias so we don't need to carry the python version around
if(NOT TARGET Boost::python )
    message("Adding Boost::python target")
    add_library(Boost::python INTERFACE IMPORTED)
    set_target_properties(Boost::python PROPERTIES
        INTERFACE_LINK_LIBRARIES  "python${Python_VERSION_MAJOR}${Python_VERSION_MINOR}" )
endif()


# Put the libraries into lib/ so that we can run this in-place in a TBX install
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY  "${CMAKE_BINARY_DIR}/lib")

add_subdirectory(src/dxtbx)

=== sphinx/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
#SPHINXBUILD   = sphinx-build
SPHINXBUILD   = sphinx.build
PAPER         =
BUILDDIR      = build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/cluster_doc.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/cluster_doc.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/cluster_doc"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/cluster_doc"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== mmtbx/probe/CMakeLists.txt ===
# SCons is the build system that is used to build CCTBX projects.
# This CMakeLists.txt and the associated files in cmake/ were used before CCTBX native
# integration and during development to enable running the C++ code within the
# Visual Studio IDE for rapid debugging.

cmake_minimum_required(VERSION 3.10.0)
project(probe)

if (WIN32)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif ()

# Find the packages we require and can use
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")
find_package(CCTBX REQUIRED)
find_package(Boost REQUIRED)

set(USE_PYTHON TRUE)
FIND_PACKAGE(PythonInterp)
if (PYTHONINTERP_FOUND)
  if (UNIX AND NOT APPLE)
    if (PYTHON_VERSION_MAJOR EQUAL 3)
        FIND_PACKAGE(Boost COMPONENTS python${PYTHON_VERSION_SUFFIX})
        FIND_PACKAGE(PythonInterp 3)
        FIND_PACKAGE(PythonLibs 3 REQUIRED)
    else()
        FIND_PACKAGE(Boost COMPONENTS python)
        FIND_PACKAGE(PythonInterp)
        FIND_PACKAGE(PythonLibs REQUIRED)
    endif()
  else()
    if (PYTHON_VERSION_MAJOR EQUAL 3)
        FIND_PACKAGE(Boost COMPONENTS python${PYTHON_VERSION_MAJOR}${PYTHON_VERSION_MINOR})
        FIND_PACKAGE(PythonInterp 3)
        FIND_PACKAGE(PythonLibs 3 REQUIRED)
    else()
        FIND_PACKAGE(Boost COMPONENTS python${PYTHON_VERSION_MAJOR}${PYTHON_VERSION_MINOR})
        FIND_PACKAGE(PythonInterp)
        FIND_PACKAGE(PythonLibs REQUIRED)
    endif()
  endif()
else()
    set(USE_PYTHON FALSE)
    message("Python not found")
endif()
if (NOT Boost_FOUND)
    set(USE_PYTHON FALSE)
endif()

set(probe_SOURCES
  Scoring.cpp
  DotSpheres.cpp
  SpatialQuery.cpp
)

set(probe_HEADERS
  Common.h
  Scoring.h
  DotSpheres.h
  SpatialQuery.h
)

add_library(probeLib ${probe_SOURCES} ${probe_HEADERS})
target_include_directories(probeLib PUBLIC SYSTEM
  ${CCTBX_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIR})
target_link_libraries(probeLib
    PUBLIC
    ${CCTBX_LIBRARIES}
    ${Boost_LIBRARIES}
    ${PYTHON_LIBRARIES}
)
if (NOT WIN32)
  target_link_libraries(probeLib PUBLIC m)
endif()

add_executable(tst_probe tst_probe.cpp)
target_link_libraries(tst_probe probeLib)
if (NOT WIN32)
  target_link_libraries(tst_probe m)
endif()

if (USE_PYTHON)
  message(STATUS "Building Boost.Python library")
  message(STATUS "PYTHON_LIBRARIES = ${PYTHON_LIBRARIES}")
  message(STATUS "PYTHON_EXECUTABLE = ${PYTHON_EXECUTABLE}")
  message(STATUS "PYTHON_INCLUDE_DIRS = ${PYTHON_INCLUDE_DIRS}")
  message(STATUS "Boost_LIBRARIES = ${Boost_LIBRARIES}")
  include_directories(../libpdb ../toolclasses ${Boost_INCLUDE_DIRS} ${PYTHON_INCLUDE_DIRS})
  # Note: To make this work on Windows, you need to copy the boost_python*.dll file into the
  # executable directory to avoid an error about "DLL load failed: The specified module could not be found".
  # We also need to copy the test program into the Release (or other build) directory before running it.
  PYTHON_ADD_MODULE(mmtbx_probe_ext boost_python/probe_bpl.cpp)
  target_link_libraries(mmtbx_probe_ext PRIVATE probeLib)

  add_custom_command(
    TARGET mmtbx_probe_ext POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy
      ${CMAKE_SOURCE_DIR}/tst_mmtbx_probe_ext.py
      ${CMAKE_CURRENT_BINARY_DIR}
  )
endif()

=== debian/changelog ===
cctbx (2025.2+ds2+~3.23.0+ds1-1) unstable; urgency=medium

  [ Picca Frédéric-Emmanuel ]
  * New upstream version 2025.2+ds2+~3.23.0+ds1

  [ Roland Mas ]
  * Bug fix: "FTBFS with the nocheck build profile", thanks to Santiago
    Vila (Closes: #1116719).
  * Bug fix: "Python SyntaxWarning", thanks to Graham Inggs (Closes:
    #1085414).

 -- Roland Mas <lolando@debian.org>  Fri, 24 Oct 2025 19:38:49 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export DEB_CXXFLAGS_MAINT_APPEND := $(shell pkg-config --cflags hdf5-serial) -DBOOST_TIMER_ENABLE_DEPRECATED=1
export DEB_LDFLAGS_MAINT_APPEND=$(shell pkg-config --libs hdf5-serial)

MODULES         = annlib_adaptbx boost_adaptbx cbflib_adaptbx ccp4io_adaptbx cctbx cma_es crys3d dxtbx fable gltbx iotbx libtbx mmtbx omptbx rstbx scitbx serialtbx smtbx spotfinder tbxx wxtbx
#MODULES_TODO    = gltbx
MODULES_FAKE    = annlib ccp4io

# avoid FTBFS when cctbx is already install edon the system (Debian specific)
export HIDE_INSTALLED_CCTBX=1

%:
	dh $@ --buildsystem=pybuild

annlib_adaptbx:
	cp -r debian/annlib_adaptbx annlib_adaptbx
	mkdir annlib

ccp4io_adaptbx:
	cp -r debian/ccp4io_adaptbx ccp4io_adaptbx
	mkdir ccp4io

gui_resources:
	cp -r debian/gui_resources gui_resources

setup.py : debian/setup.py
	cp -f $< $@

override_dh_auto_clean: setup.py annlib_adaptbx ccp4io_adaptbx gui_resources
	dh_auto_clean
	find . -name __pycache__ -type d -exec rm -rf {} \;
	rm -f setup.py
	rm -rf annlib annlib_adaptbx
	rm -rf ccp4io ccp4io_adaptbx
	rm -rf gui_resources

override_dh_auto_configure: setup.py annlib_adaptbx ccp4io_adaptbx gui_resources
	# configure the cctbx python modules
	dh_auto_configure

	# configure dxtbx python modules
	dh_auto_configure --sourcedirectory=dxtbx

	# configure the cctbx libtbx build system
	dh_auto_configure -- -s custom --configure-args="mkdir -p {build_dir}_ && cd {build_dir}_ \
		&& {interpreter} $(CURDIR)/libtbx/configure.py --build=debug --use_environment_flags --cxxstd=c++14 $(MODULES) $(MODULES_FAKE)"

override_dh_auto_build: setup.py annlib_adaptbx ccp4io_adaptbx gui_resources
	# build the python modules
	dh_auto_build

	# build the dxtbx python module
	dh_auto_build --sourcedirectory=dxtbx

	# build the cctbx extensions and libraries
	dh_auto_build -- -s custom --build-args="cd {build_dir}_ && ./bin/libtbx.scons $(DEB_BUILD_OPTION_PARALLEL:%=-j %)"
	iconv -f ISO-8859-1 -t UTF-8 cctbx/eltbx/covalent_radii.h > covalent_radii.h
	mv covalent_radii.h cctbx/eltbx/covalent_radii.h

	# cp all extensions into the python build directory
	# special case for an extension used during test
	dh_auto_build -- -s custom --build-args="cp -f {build_dir}_/lib/*_ext.so {build_dir}_/scitbx/array_family/boost_python/regression_test_ext.so {build_dir}"

	# cp the dxtbx pybind11 extension at the right place.
	dh_auto_build -- -s custom --build-args="cp -f {build_dir}_/lib/dxtbx_flumpy.so {build_dir}"

override_dh_auto_install: setup.py annlib_adaptbx ccp4io_adaptbx gui_resources
	# install the cctbx python modules
	dh_auto_install

	# install the dxtbx python modules
	dh_auto_install --sourcedirectory=dxtbx

	# specific installation for the cctbx build directory
	dh_auto_install -- -s custom --install-args="debian/install-cctbx.sh -- --pyver={version} --srcdir=$(CURDIR) --builddir={build_dir}_ --modules='$(MODULES)'"

override_dh_link:
	dh_auto_build -- -s custom --build-args="dh_link -p libcctbx-dev usr/include/cctbx usr/lib/cctbx/python{version}/include"

override_dh_auto_test:
	# DOES NOT WORK, source code must be modified in order to find the expected
	# /usr/share/cctbx libtbx_env file during the build process

# target used to trace the embeded git repository used to build cctbx
# a bunche of modules are missing in the original git repository, so embed them for now
embed:
	# annlib_adaptbx
	-git clone http://github.com/cctbx/annlib_adaptbx annlib_adaptbx_tmp
	rm -rf annlib_adaptbx_tmp/.git*
	rm -rf annlib_adaptbx
	mv annlib_adaptbx_tmp annlib_adaptbx

	# cpp4io_adaptbx
	-git clone http://github.com/cctbx/ccp4io_adaptbx ccp4io_adaptbx_tmp
	rm -rf ccp4io_adaptbx_tmp/.git*
	rm -rf ccp4io_adaptbx
	mv ccp4io_adaptbx_tmp ccp4io_adaptbx

	# gui_resources
	-git clone http://github.com/cctbx/gui_resources gui_resources_tmp
	rm -rf gui_resources_tmp/.git*
	rm -rf gui_resources_tmp/icons
	rm -rf gui_resources_tmp/gl2ps
	rm -rf gui_resources
	mv gui_resources_tmp gui_resources

.PHONY: embed

=== debian/watch ===
version=4
opts="repacksuffix=+ds2,dversionmangle=auto,repack,compression=xz,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
   https://github.com/cctbx/cctbx_project/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz group
opts="repacksuffix=+ds1,dversionmangle=auto,repack,compression=xz,component=dxtbx,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
   https://github.com/cctbx/dxtbx/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz group

## cctbx 2025.12+ds2+~3.26.0+ds1

=== debian/changelog ===
cctbx (2025.12+ds2+~3.26.0+ds1-2) unstable; urgency=medium

  * d/patches/0029-iotbx-fix-buffer-overflow.patch
  * Added loong64 support.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 07 Jan 2026 14:31:56 +0100

cctbx (2025.12+ds2+~3.26.0+ds1-1) unstable; urgency=medium

  * New upstream version 2025.12+ds2+~3.26.0+ds1
  * d/patches: refresh series for new upstream version
  * d/control: Added B-D
  * d/install-cctbx.sh: Added a few files for test
  * Bug fix: "ftbfs with pip 25.3", thanks to Étienne Mollier (Closes:
    #1119699).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Tue, 06 Jan 2026 19:00:31 +0100

=== debian/control ===
Source: cctbx
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Picca Frédéric-Emmanuel <picca@debian.org>,
 Radostan Riedel <raybuntu@googlemail.com>,
 Roland Mas <lolando@debian.org>,
Section: science
Priority: optional
Build-Depends:
 architecture-is-64-bit,
 bash,
 debhelper-compat (= 13),
 dh-exec,
 dh-python,
 dh-sequence-numpy3,
 dh-sequence-python3,
 jq,
 libann-cctbx-dev (>= 1.1.2+doc-9~),
 libantlr3c-dev,
 libboost-dev,
 libboost-numpy-dev,
 libboost-python-dev,
 libboost-thread-dev,
 libboost-timer-dev,
 libcbf-dev (>= 0.9.7+dfsg1-2~),
 libclipper-dev,
 libeigen3-dev,
 libexpat1-dev,
 libfftw3-dev,
 libgl-dev,
 libglu1-mesa-dev,
 libhdf5-dev,
 liblz4-dev,
 libssm-dev,
 libtiff-dev,
 libtool,
 pybind11-dev,
 pybuild-plugin-pyproject,
 python3-all-dev:any,
 python3-biopython <!nocheck>,
 python3-editables,
 python3-hatchling,
 python3-h5py (>= 3) <!nocheck>,
 python3-hdf5plugin <!nocheck>,
 python3-legacy-cgi <!nocheck>,
 python3-matplotlib <!nocheck>,
 python3-mrcfile <!nocheck>,
 python3-msgpack <!nocheck>,
 python3-natsort <!nocheck>,
 python3-numpy <!nocheck>,
 python3-nxmx <!nocheck>,
 python3-ordered-set <!nocheck>,
 python3-pint <!nocheck>,
 python3-pip,
 python3-procrunner <!nocheck>,
 python3-psutil <!nocheck>,
 python3-pycbf (>= 0.9.7+dfsg1-2~) <!nocheck>,
 python3-pymol <!nocheck>,
 python3-pytest <!nocheck>,
 python3-requests <!nocheck>,
 python3-scipy <!nocheck>,
 python3-setuptools,
 python3-six,
 python3-tqdm <!nocheck>,
 python3-wxgtk4.0 <!nocheck>,
 rsync,
 scons,
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/cctbx
Vcs-Git: https://salsa.debian.org/science-team/cctbx.git
Homepage: https://github.com/cctbx/cctbx_project
Rules-Requires-Root: no

Package: libcctbx0
Architecture: amd64 arm64 armel armhf i386 loong64 ppc64 ppc64el riscv64 s390x
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Computational Crystallography Toolbox - runtime libraries
 Computational Crystallography Toolbox contains following modules:
    - annlib_adaptbx:
    - boost_adaptbx: wrappers for Boost functionality in CCTBX
    - cbflib_adaptbx:
    - ccp4io_adaptbx:
    - cctbx: Libraries for general crystallographic applications,
             useful for both small-molecule and macro-molecular
             crystallography.
    - cma_es:
    - crys3d: Modules for the display of molecules, electron density,
              and reciprocal space data.
    - dxtbx: The Diffraction Image Toolbox, a library for handling
             X-ray detector data of arbitrary complexity from a variety
             of standard formats.
    - fable: Fortran EMulation library  for porting Fortran77 to C++.
    - gltbx: Python bindings for OpenGL
    - iotbx: Working with common crystallographic file formats.
    - libtbx: The build system common to all other modules. This includes
              a very thin wrapper around the SCons software construction tool.
              It also contains many useful frameworks and utilities to simplify
              application development, including tools for regression testing,
              parallelization across multiprocessor systems and managed clusters,
              and a flexible, modular configuration syntax called PHIL
              (Python Hierarchial Interface Language) used throughout the CCTBX.
    - mmtbx: Functionality specific to macromolecular crystallography.
             This includes all of the machinery required for setup of
             geometry restraints, bulk solvent correction and scaling,
             analysis of macromolecular diffraction data, calculation of
             weighted map coefficients, and most of the methods implemented
             in phenix.refine. The majority of infrastructure for the MolProbity
             validation server (and Phenix equivalent) is also located here.
    - omptbx: OpenMP interface.
    - rstbx: A reciprocal space toolbox to autoindex small molecule Bragg
             diffraction, given the reciprocal space vectors.
    - scitbx: General scientific calculations. his includes a family of
      high-level C++ array types, a fast Fourier transform library,
      and a C++ port of the popular L-BFGS quasi-Newton minimizer.
    - smtbx: Small-Molecule crystallography.
    - spotfinder:
    - tbxx:
    - wxtbx: wxPython controls used in the Phenix GUI and various
        utilities
 .
 This package provide the cctbx runtime libraries.

Package: libcctbx-dev
Architecture: amd64 arm64 armel armhf i386 loong64 ppc64 ppc64el riscv64 s390x
Depends:
 libann-cctbx-dev,
 libboost-python-dev,
 libccp4-dev,
 libcctbx0 (= ${binary:Version}),
 ${misc:Depends},
Section: devel
Description: Computational Crystallography Toolbox - headers
 Computational Crystallography Toolbox contains following modules:
    - annlib_adaptbx:
    - boost_adaptbx: wrappers for Boost functionality in CCTBX
    - cbflib_adaptbx:
    - ccp4io_adaptbx:
    - cctbx: Libraries for general crystallographic applications,
             useful for both small-molecule and macro-molecular
             crystallography.
    - cma_es:
    - crys3d: Modules for the display of molecules, electron density,
              and reciprocal space data.
    - dxtbx: The Diffraction Image Toolbox, a library for handling
             X-ray detector data of arbitrary complexity from a variety
             of standard formats.
    - fable: Fortran EMulation library  for porting Fortran77 to C++.
    - gltbx: Python bindings for OpenGL
    - iotbx: Working with common crystallographic file formats.
    - libtbx: The build system common to all other modules. This includes
              a very thin wrapper around the SCons software construction tool.
              It also contains many useful frameworks and utilities to simplify
              application development, including tools for regression testing,
              parallelization across multiprocessor systems and managed clusters,
              and a flexible, modular configuration syntax called PHIL
              (Python Hierarchial Interface Language) used throughout the CCTBX.
    - mmtbx: Functionality specific to macromolecular crystallography.
             This includes all of the machinery required for setup of
             geometry restraints, bulk solvent correction and scaling,
             analysis of macromolecular diffraction data, calculation of
             weighted map coefficients, and most of the methods implemented
             in phenix.refine. The majority of infrastructure for the MolProbity
             validation server (and Phenix equivalent) is also located here.
    - omptbx: OpenMP interface.
    - rstbx: A reciprocal space toolbox to autoindex small molecule Bragg
             diffraction, given the reciprocal space vectors.
    - scitbx: General scientific calculations. his includes a family of
      high-level C++ array types, a fast Fourier transform library,
      and a C++ port of the popular L-BFGS quasi-Newton minimizer.
    - smtbx: Small-Molecule crystallography.
    - spotfinder:
    - tbxx:
    - wxtbx: wxPython controls used in the Phenix GUI and various
        utilities
 .
 This package provide everythings needed to link against the cctbx libraries.

Package: python3-cctbx
Architecture: amd64 arm64 armel armhf i386 loong64 ppc64 ppc64el riscv64 s390x
Section: python
Depends:
 ca-certificates,
 libcctbx-dev (= ${binary:Version}),
 libcctbx0 (= ${binary:Version}),
 python3-legacy-cgi,
 python3-pycbf (>= 0.9.7+dfsg1-2~),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python Toolbox for crystallography
 Computational Crystallography Toolbox contains following modules:
    - annlib_adaptbx:
    - boost_adaptbx: wrappers for Boost functionality in CCTBX
    - cbflib_adaptbx:
    - ccp4io_adaptbx:
    - cctbx: Libraries for general crystallographic applications,
             useful for both small-molecule and macro-molecular
             crystallography.
    - cma_es:
    - crys3d: Modules for the display of molecules, electron density,
              and reciprocal space data.
    - dxtbx: The Diffraction Image Toolbox, a library for handling
             X-ray detector data of arbitrary complexity from a variety
             of standard formats.
    - fable: Fortran EMulation library  for porting Fortran77 to C++.
    - gltbx: Python bindings for OpenGL
    - iotbx: Working with common crystallographic file formats.
    - libtbx: The build system common to all other modules. This includes
              a very thin wrapper around the SCons software construction tool.
              It also contains many useful frameworks and utilities to simplify
              application development, including tools for regression testing,
              parallelization across multiprocessor systems and managed clusters,
              and a flexible, modular configuration syntax called PHIL
              (Python Hierarchial Interface Language) used throughout the CCTBX.
    - mmtbx: Functionality specific to macromolecular crystallography.
             This includes all of the machinery required for setup of
             geometry restraints, bulk solvent correction and scaling,
             analysis of macromolecular diffraction data, calculation of
             weighted map coefficients, and most of the methods implemented
             in phenix.refine. The majority of infrastructure for the MolProbity
             validation server (and Phenix equivalent) is also located here.
    - omptbx: OpenMP interface.
    - rstbx: A reciprocal space toolbox to autoindex small molecule Bragg
             diffraction, given the reciprocal space vectors.
    - scitbx: General scientific calculations. his includes a family of
      high-level C++ array types, a fast Fourier transform library,
      and a C++ port of the popular L-BFGS quasi-Newton minimizer.
    - smtbx: Small-Molecule crystallography.
    - spotfinder:
    - tbxx:
    - wxtbx: wxPython controls used in the Phenix GUI and various
        utilities
 .
 This package provide a selected collection of python modules from the cctbx project.

## cctbx 2026.1+ds2+~3.26.0+ds1

=== dxtbx/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20...3.30 FATAL_ERROR)

project(dxtbx LANGUAGES C CXX)

# Add the included modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")

# General cmake environment configuration
include(SetDefaultBuildRelWithDebInfo) # Default builds to release with debug info
include(AlwaysColourCompilation) # Always show coloured compiler output
set(CMAKE_EXPORT_COMPILE_COMMANDS ON) # Generate compile_commands.json
set(CMAKE_CXX_STANDARD 14)

# Handle unity build on Windows
if (CMAKE_UNITY_BUILD AND MSVC)
    add_compile_options(/bigobj)
endif()

find_package(Python REQUIRED COMPONENTS Interpreter Development)
find_package(CCTBX COMPONENTS scitbx cctbx REQUIRED)
find_package(pybind11 REQUIRED)
find_package(CBFlib)

set(HDF5_USE_STATIC_LIBRARIES OFF)
find_package(HDF5 REQUIRED)
if(WIN32)
    # This is required on windows to declare symbols as external
    target_compile_definitions(hdf5::hdf5 INTERFACE H5_BUILT_AS_DYNAMIC_LIB)
endif()

# Find the boost::python library for this version of python
set(Boost_USE_STATIC_LIBS OFF) # This is the default everywhere except Windows
find_package(Boost COMPONENTS "python${Python_VERSION_MAJOR}${Python_VERSION_MINOR}" REQUIRED)


# Create Boost::python alias so we don't need to carry the python version around
if(NOT TARGET Boost::python )
    message("Adding Boost::python target")
    add_library(Boost::python INTERFACE IMPORTED)
    set_target_properties(Boost::python PROPERTIES
        INTERFACE_LINK_LIBRARIES  "python${Python_VERSION_MAJOR}${Python_VERSION_MINOR}" )
endif()


# Put the libraries into lib/ so that we can run this in-place in a TBX install
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY  "${CMAKE_BINARY_DIR}/lib")

add_subdirectory(src/dxtbx)

=== dxtbx/src/dxtbx/CMakeLists.txt ===

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/..)

Python_add_library( dxtbx_ext
    MODULE
    boost_python/ext.cpp
    boost_python/compression.cc )
target_link_libraries(dxtbx_ext PRIVATE Boost::python CCTBX::scitbx)

Python_add_library( dxtbx_format_nexus_ext MODULE format/boost_python/nexus_ext.cc )
target_link_libraries( dxtbx_format_nexus_ext PRIVATE  Boost::python CCTBX::scitbx hdf5::hdf5 )

Python_add_library( dxtbx_imageset_ext MODULE boost_python/imageset_ext.cc )
target_link_libraries( dxtbx_imageset_ext PUBLIC Boost::python CCTBX::scitbx CCTBX::scitbx::boost_python )

Python_add_library( dxtbx_format_image_ext
    MODULE
    format/boost_python/image_ext.cc
)
target_link_libraries( dxtbx_format_image_ext PUBLIC Boost::python CCTBX::scitbx HDF5::HDF5)
# If we have CBFlib available, use it
if (TARGET CBFlib::cbf)
    target_link_libraries( dxtbx_format_image_ext PRIVATE CBFlib::cbf )
    target_compile_definitions( dxtbx_format_image_ext PRIVATE BUILD_CBF )
    target_sources( dxtbx_format_image_ext PRIVATE format/boost_python/cbf_read_buffer.cpp )
endif()

Python_add_library( dxtbx_model_ext
    MODULE
    model/boost_python/beam.cc
    model/boost_python/spectrum.cc
    model/boost_python/goniometer.cc
    model/boost_python/kappa_goniometer.cc
    model/boost_python/multi_axis_goniometer.cc
    model/boost_python/panel.cc
    model/boost_python/detector.cc
    model/boost_python/scan.cc
    model/boost_python/scan_helpers.cc
    model/boost_python/crystal.cc
    model/boost_python/parallax_correction.cc
    model/boost_python/pixel_to_millimeter.cc
    model/boost_python/history.cc
    model/boost_python/experiment.cc
    model/boost_python/experiment_list.cc
    model/boost_python/model_ext.cc )
target_link_libraries(
    dxtbx_model_ext
    PUBLIC
    Boost::python
    CCTBX::scitbx
)
if(WIN32)
    # Technically required on other platforms, but already loaded by time
    # of use in dxtbx, and a bug with -install_name settings for these
    # prevents direct linking from working on MacOS without fiddling
    # around with install_name_tool.
    target_link_libraries(
        dxtbx_model_ext
        PUBLIC
        CCTBX::scitbx::boost_python
        CCTBX::cctbx
    )
endif()

Python_add_library( dxtbx_masking_ext
    MODULE
    masking/boost_python/ext.cc )
target_link_libraries( dxtbx_masking_ext PUBLIC Boost::python CCTBX::scitbx )

pybind11_add_module(dxtbx_flumpy boost_python/flumpy.cc)
target_link_libraries(dxtbx_flumpy PUBLIC Boost::python CCTBX::scitbx )

include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-fvisibility=hidden HAS_VISIBILITY)
if(HAS_VISIBILITY)
    target_compile_options(dxtbx_flumpy PRIVATE -fvisibility=hidden)
endif()

# pybind11 causes a bounds checking warning on recent compilers
check_cxx_compiler_flag("-Wno-array-bounds" HAS_BOUNDS_WARNING)
check_cxx_compiler_flag("-Wno-stringop-overread" HAS_OVERREAD_WARNING)
if(HAS_BOUNDS_WARNING AND HAS_OVERREAD_WARNING)
    target_compile_options(dxtbx_flumpy PRIVATE -Wno-array-bounds -Wno-stringop-overread)
endif()

install(
    TARGETS
        dxtbx_ext
        dxtbx_format_nexus_ext
        dxtbx_imageset_ext
        dxtbx_format_image_ext
        dxtbx_model_ext
        dxtbx_masking_ext
        dxtbx_flumpy
    DESTINATION "${Python_SITEARCH}"
)

=== debian/changelog ===
cctbx (2026.1+ds2+~3.26.0+ds1-1ubuntu1) resolute; urgency=medium

  * Fix ftbfs with boost 1.90, boost_system is gone.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 07 Feb 2026 11:38:04 +0100

cctbx (2026.1+ds2+~3.26.0+ds1-1build1) resolute; urgency=medium

  * No-change rebuild for boost 1.90.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 04 Feb 2026 14:20:58 +0100

cctbx (2026.1+ds2+~3.26.0+ds1-1) unstable; urgency=medium

  * New upstream version 2026.1+ds2+~3.26.0+ds1
  * d/p/iotbx-increase-buffer-size-to-avoid-buffer-overflow.patch: Deleted

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Tue, 03 Feb 2026 13:21:34 +0100

cctbx (2025.12+ds2+~3.26.0+ds1-3) unstable; urgency=medium

  * Team upload.
  * Fix one autopkgtest that fails on ppc64el/riscv64/s390x
  * Drop "Rules-Requires-Root: no": it is the default now

 -- Alexandre Detiste <tchet@debian.org>  Wed, 21 Jan 2026 17:27:59 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,6 @@
  Radostan Riedel <raybuntu@googlemail.com>,
  Roland Mas <lolando@debian.org>,
 Section: science
-Priority: optional
 Build-Depends:
  architecture-is-64-bit,
  bash,
@@ -65,11 +64,10 @@
  python3-wxgtk4.0 <!nocheck>,
  rsync,
  scons,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/science-team/cctbx
 Vcs-Git: https://salsa.debian.org/science-team/cctbx.git
 Homepage: https://github.com/cctbx/cctbx_project
-Rules-Requires-Root: no
 
 Package: libcctbx0
 Architecture: amd64 arm64 armel armhf i386 loong64 ppc64 ppc64el riscv64 s390x
